/*********************************************
 * GLOBAL STYLES
 *********************************************/

html
{
  overflow: hidden;
}

body
{
  margin: 0;
  padding: 0;
}

::selection {
  color: $selectionColor;
  background: $selectionBackgroundColor;
  text-shadow: none;
}

.slides > .slide > .slide-content
{
  table-layout:fixed;
  display: table;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 80%;
}

.slides > .slide > .slide-content > .slide-content-child
{
  display: table-cell;
  vertical-align: middle;
}

.slides > .slide > .slide-number {
  color: $mainColor;
  font-family: $mainFont;
  font-size: 1.2em;
  font-weight: 200;
  position: absolute;
  bottom: 5mm;
  right: 5mm;
  text-align: center;
}

/*********************************************
 * HEADERS
 *********************************************/

h1,
h2,
h3,
h4,
h5,
h6 {
    font-family: $headingFont;
    line-height: $headingLineHeight;
    letter-spacing: $headingLetterSpacing;
    word-wrap: break-word;
}

h1 {
    font-size: $heading1FontSize;
    font-weight: $heading1FontHeight;
    text-shadow: $heading1TextShadow;
    text-transform: $heading1TextTransform;
    color: $heading1Color;
}

h2 {
    font-size: $heading2FontSize;
    font-weight: $heading2FontHeight;
    text-shadow: $heading2TextShadow;
    text-transform: $heading2TextTransform;
    color: $heading2Color;
}

h3 {
    font-size: $heading3FontSize;
    font-weight: $heading3FontHeight;
    text-shadow: $heading3TextShadow;
    text-transform: $heading3TextTransform;
    color: $heading3Color;
}

h4 {
    font-size: $heading4FontSize;
    font-weight: $heading4FontHeight;
    text-shadow: $heading4TextShadow;
    text-transform: $heading4TextTransform;
    color: $heading4Color;
}

h5 {
    font-size: $heading5FontSize;
    font-weight: $heading5FontHeight;
    text-shadow: $heading5TextShadow;
    text-transform: $heading5TextTransform;
    color: $heading5Color;
}

h6 {
    font-size: $heading6FontSize;
    font-weight: $heading6FontHeight;
    text-shadow: $heading6TextShadow;
    text-transform: $heading6TextTransform;
    color: $heading6Color;
}

label {
    text-align: left;
    font-family: $mainFont;
    font-size: $mainFontSize;
    font-weight: $mainFontHeight;
    color: $mainColor;
}

/*********************************************
 * BLOCK MARGIN
 *********************************************/

p,
pre,
blockquote,
ol,
dl,
ul,
h1,
h2,
h3,
h4,
h5,
h6
{
  margin: auto;
  margin-bottom: $blockMargin;
}

p:last-child,
blockquote:last-child,
ol:last-child,
dl:last-child,
ul:last-child,
li:last-child,
h1:last-child,
h2:last-child,
h3:last-child,
h4:last-child,
h5:last-child,
h6:last-child
{
  margin-left: auto;
  margin-right: auto;
  margin-bottom: 0;
}

h1 + h2,
h1 + h3,
h1 + h4,
h1 + h5,
h1 + h6,
h2 + h3,
h2 + h4,
h2 + h5,
h2 + h6,
h3 + h4,
h3 + h5,
h3 + h6,
h4 + h5,
h4 + h6,
h5 + h6, {
  margin-top: -$blockMarginSmall;
}

/*********************************************
 * OTHER
 *********************************************/

p {
    font-family: $mainFont;
    font-size: $mainFontSize;
    font-weight: $mainFontHeight;
    line-height: 1.3;
}

p.center {
    text-align: center;
}

p.right {
    text-align: right;
}

p.left {
    text-align: left;
}

p.justify {
    text-align: justify;
}

/* Ensure certain elements are never larger than the slide itself */
img,
video,
iframe {
    max-width: 95%;
    max-height: 95%;
}

img,
video,
svg {
    border: $imageBorder;
    -moz-border-radius: $imageBorderRadius;
    -webkit-border-radius: $imageBorderRadius;
    border-radius: $imageBorderRadius;
    box-shadow: $imageShadow;
    margin: 5px;
}

svg {
  background: white;
  padding: 5px;
}

strong,
b {
    font-weight: bold;
}

em {
    font-style: italic;
}

ol,
dl,
ul {
    font-size: $mainFontSize;
    font-family: $mainFont;
    font-weight: $mainFontHeight;
    display: inline-block;
    text-align: left;
}

li {
    margin-bottom: $blockMargin;
}

li > p {
    font-size: inherit;
}

ol {
    list-style-type: decimal;
    font-family: $secondFont;
}

ol > li {
    text-align: left;
}

ul {
    list-style-type: disc;
}

ul ul {
    list-style-type: disc;
    margin-top: 20px;
    margin-bottom: 15px;
}

ol ol {
    margin-top: 20px;
}

ul ul ul {
    list-style-type: disc;
}

ul ul,
ul ol,
ol ol,
ol ul {
    display: block;
    margin-left: 40px;
}

dt {
    font-weight: bold;
}

dd {
    margin-left: 40px;
}

dl.inline dt,
dl.inline dd {
    float: left;
    margin: 0 0.5em 0 0;
    background: #ccc
}

dl.inline dd + dt,
dl.inline dd + dd {
    clear: left
}

dl.inline dd + dd {
    float: none
}

dl.inline dt {
    font-weight: bold
}

q,
blockquote {
    quotes: none;
}

blockquote {
    display: block;
    position: relative;
    width: 70%;

    font-family: $serifFont;
    font-style: italic;
    font-size: $blockquoteSize;

    background-color: $blockquoteBackgroundColor;
    border-radius: 10px;
    padding: $blockquotePadding;
}

blockquote p {
  margin: 0;
}

q {
    font-style: italic;
}

pre {
    display: block;
    position: relative;
    width: 90%;
    padding: 0;

    font-size: $codeSize;
    font-family: $codeFont;
    text-align: left;
    color: $codeColor;

    word-wrap: break-word;
    box-shadow: $codeBoxShadow;
    border: $codeBorder;
    border-radius: $codeBorderRadius;
    background: $codeBackgroundColor;
}

code {
    font-family: $codeFont;
    color: $codeColor;
}

pre code {
    display: block;
    padding: 5px;
    overflow: auto;
    word-wrap: normal;
}

table {
    font-size: $mainFontSize;
    margin: auto;
    border-collapse: collapse;
    border-spacing: 0;
}

table th {
    font-weight: bold;
}

table th,
table td {
    text-align: left;
    padding: 0.2em 0.5em 0.2em 0.5em;
    border-bottom: 1px solid;
}

table th[align="center"],
table td[align="center"] {
    text-align: center;
}

table th[align="right"],
table td[align="right"] {
    text-align: right;
}

table tr:last-child td {
    border-bottom: none;
}

sup {
    vertical-align: super;
}

sub {
    vertical-align: sub;
}

small {
    display: inline-block;
    font-size: 0.6em;
    line-height: 1.2em;
    vertical-align: top;
}

small * {
    vertical-align: top;
}

/*********************************************
 * LINKS
 *********************************************/

a {
    color: $linkColor;
    text-decoration: none;

    -webkit-transition: color .15s ease;
       -moz-transition: color .15s ease;
            transition: color .15s ease;
}

a:hover {
    color: $linkColorHover;
    text-shadow: none;
    border: none;
}

.roll span:after {
    color: #fff;
    background: darken( $linkColor, 15% );
}
